package controleur;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import info1.ships.AircraftCarrier;
import info1.ships.BadCoordException;
import info1.ships.Battleship;
import info1.ships.Coord;
import info1.ships.CoordsBadShipException;
import info1.ships.Cruiser;
import info1.ships.Destroyer;
import info1.ships.ICoord;
import info1.ships.IShip;
import info1.ships.Submarine;
import vue.*;

public class ButtonCreateFleetControleur implements ActionListener, MouseListener{
	private FenLog log;
	

	public ButtonCreateFleetControleur(FenLog log) {
		this.log=log;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
 		JButton recup = (JButton) e.getSource();
		Coord coords;
			try {
				coords = new Coord(recup.getName());
				
				if (log.getTmpCoords().isEmpty() && log.getEtapeCreation() != 14 && log.getEtapeCreation() != 15 && log.getEtapeCreation() != 16 && log.getEtapeCreation() != 17) {
					log.getTmpCoords().add(coords);
					log.setMessage("Maintenant selectionnez l'arrière du bateau.");
				}else {
					switch (log.getEtapeCreation()) {
					// FRANCE
					case 1:
						try {
							IShip n_ship = new Battleship("Cuirassé", log.getTmpCoords().get(0).toString(), coords.toString());
							
							if (!isTaken(n_ship)) {
								log.getFlotte().add(n_ship);
								this.Colorize(n_ship);
								log.setMessage("Création du cuirassé réussie. <br> Placez votre premier croiseur  (Longueur : 3).");
								log.increaseEtapeCreation();
							}
						}
						catch(BadCoordException | CoordsBadShipException e1) {
							log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 4 cases.</p>");
						}
						break;	
					case 2:
						try {
							IShip n_ship = new Cruiser("Croiseur 1", log.getTmpCoords().get(0).toString(), coords.toString());
							
							if (!isTaken(n_ship)) {
								if (n_ship.getCoords().size() == 3) {
									log.getFlotte().add(n_ship);
									this.Colorize(n_ship);
									log.setMessage("Création du premier croiseur réussie. <br> Placez votre deuxième croiseur (Longueur : 3).");
									log.increaseEtapeCreation();
								}
							}
						}
						catch(BadCoordException | CoordsBadShipException e1) {
							log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 3 cases.</p>");
						}
						break;	
					case 3:
						try {
							IShip n_ship = new Cruiser("Croiseur 2", log.getTmpCoords().get(0).toString(), coords.toString());
							
							if (!isTaken(n_ship)) {

								if (n_ship.getCoords().size() == 3) {
									log.getFlotte().add(n_ship);			
									this.Colorize(n_ship);
									log.setMessage("Création du deuxièle croiseur réussie. <br> Placez votre premier destroyeur (Longueur : 2).");
									log.increaseEtapeCreation();
								}
							}
						}
						catch(BadCoordException | CoordsBadShipException e1) {
							log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 3 cases.</p>");
						}
						break;
					case 4:
						try {
							IShip n_ship = new Destroyer("Destroyeur 1", log.getTmpCoords().get(0).toString(), coords.toString());
							
							if (!isTaken(n_ship)) {
								log.getFlotte().add(n_ship);
								this.Colorize(n_ship);
								log.setMessage("Création du premier destroyeur réussie. <br> Placez votre deuxième déstroyeur (Longueur : 2).");
								log.increaseEtapeCreation();
							}
						}
						catch(BadCoordException | CoordsBadShipException e1) {
							log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 2 cases.</p>");
						}
						break;
					case 5:
						try {
							IShip n_ship = new Destroyer("Destroyeur 2", log.getTmpCoords().get(0).toString(), coords.toString());
							
							if (!isTaken(n_ship)) {
								log.getFlotte().add(n_ship);
								this.Colorize(n_ship);
								log.setMessage("Création du deuxième destroyeur. <br> Placez votre sous-marin (longueur : 1).");
								log.increaseEtapeCreation();
							}
						}
						catch(BadCoordException | CoordsBadShipException e1) {
							log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 2 cases.</p>");
						}
						break;
						
						case 6:
							try {
								IShip n_ship = new Submarine("Sous marin", coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);
									log.setMessage("Création du sous-marin réussie. <br> Placez votre porte avion (Longueur : 5).");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 1 cases.</p>");
							}
							break;
						case 7:
							try {
								IShip n_ship = new AircraftCarrier("Porte avion", log.getTmpCoords().get(0).toString(), coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									this.Colorize(n_ship);
									log.setMessage("Création du porte avion réussie.");
									
									if (log.getFlotte().isFrenchConfiguration()) {	
										log.setMessage("Votre flotte Française a était créé.");
										log.increaseEtapeCreation();
										log.goMenu();
									}else {
										log.setMessage("Votre flotte Française n'a pas était créé. Veuillez ré-essayer.");
									}
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 5 cases.</p>");
							}
							break;
						// BELGIQUE
						case 8:
							try {
								IShip n_ship = new Battleship("Cuirassé", log.getTmpCoords().get(0).toString(), coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									this.Colorize(n_ship);

									log.setMessage("Création du cuirassé réussie. <br> Placez votre premier croiseur. (Longueur : 3)");
									log.increaseEtapeCreation();
								}
								
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 4 cases.</p>");
							}
							break;
							
						case 9:
							try {
								IShip n_ship = new Cruiser("Croiseur 1", log.getTmpCoords().get(0).toString(), coords.toString());
								
								if (n_ship.getCoords().size() == 3) {
									if (!isTaken(n_ship)) {
										log.getFlotte().add(n_ship);
										this.Colorize(n_ship);
										log.setMessage("Création du premier croiseur réussie. <br> Placez votre second croiseur. (Longueur : 3)");
										log.increaseEtapeCreation();
									}
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. La création a échoué. Le bateau doit avoir une longueur de 3 cases.</p>");
							}
							break;
							
						case 10:
							try {								
								IShip n_ship = new Cruiser("Croiseur 2", log.getTmpCoords().get(0).toString(), coords.toString());

								if (n_ship.getCoords().size() == 3) {
									if (!isTaken(n_ship)) {
										log.getFlotte().add(n_ship);
										
										this.Colorize(n_ship);
										log.setMessage("Création du second croiseur réussie. <br> Placez votre premier torpieur. (Longueur : 2)");
										log.increaseEtapeCreation();
									}
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. La création a échoué. Le bateau doit avoir une longueur de 3 cases.</p>");
							}
							break;
							
						case 11:
							try {
								IShip n_ship = new Destroyer("Torpieur 1", log.getTmpCoords().get(0).toString(), coords.toString());

								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);
									log.setMessage("Création du premier torpieur réussie. <br> Placez votre second torpieur. (Longueur : 2)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 2 cases.</p>");
							}
							break;
							
						case 12:
							try {
								IShip n_ship = new Destroyer("Torpieur 2", log.getTmpCoords().get(0).toString(), coords.toString());

								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);
									log.setMessage("Création du second torpilleur réussie. <br> Placez votre troisième torpieur. (Longueur : 2)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 2 cases.</p>");
							}
							break;
							
							
						case 13:
							try {
								IShip n_ship = new Destroyer("Torpieur 3", log.getTmpCoords().get(0).toString(), coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);
									log.setMessage("Création du troisième torpilleur réussie. <br> Placez votre premier sous-marin. (Longueur : 1)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 2 cases.</p>");
							}
							break;
							
						case 14:
							try {
								IShip n_ship = new Submarine("Sous-marin 1", coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);

									log.setMessage("Création du premier sous-marin réussie. <br> Placez votre second sous-marin. (Longueur : 1)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 1 cases.</p>");
							}
							break;
							
							
						case 15:
							try {
								IShip n_ship = new Submarine("Sous-marin 2", coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);

									log.setMessage("Création du second sous-marin réussie. <br> Placez votre troisème sous-marin. (Longueur : 1)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 1 cases.</p>");
							}
							break;
							
							
						case 16:
							try {
								IShip n_ship = new Submarine("Sous-marin 3", coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);

									log.setMessage("Création du troisième sous-marin réussie. <br> Placez votre quatrième sous-marin. (Longueur : 1)");
									log.increaseEtapeCreation();
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 1 cases.</p>");
							}
							break;
						case 17:
							try {
								IShip n_ship = new Submarine("Sous-marin 4", coords.toString());
								
								if (!isTaken(n_ship)) {
									log.getFlotte().add(n_ship);
									
									this.Colorize(n_ship);

									log.setMessage("Création du quatrième sous-marin réussie.");
									log.increaseEtapeCreation();
									
									if (log.getFlotte().isBelgianConfiguration()) {	
										log.setMessage("Votre flotte Belge a était créé. Bonne chance !");
										log.increaseEtapeCreation();
										log.goMenu();
									}else {
										log.setMessage("Votre flotte Belge n'a pas était créé. Veuillez ré-essayer.");
									}
								}
							}
							catch(BadCoordException | CoordsBadShipException e1) {
								log.setMessage("<p style='color: #e74c3c;'>La création a échoué. Le bateau doit avoir une longueur de 1 cases.</p>");
							}
							break;
							
						default:
							log.goMenu();
							break;
					}
					
					if (log.getEtapeCreation() != 6) {
						log.getTmpCoords().remove(0);
					}
				}
			} catch (BadCoordException e1) {
				e1.printStackTrace();
			}
	}
	
	public void Colorize(IShip n_ship ) {
		for (ICoord c : n_ship.getCoords()) {
			if(c.equals(n_ship.getCoords().get(0))){
				log.getButtonGrilleHaut()[c.getX()-1][c.getY()-1].setBackground(new Color(0x95a5a6));		
			}
			else {
				log.colorizeNone(log.getButtonGrilleHaut()[c.getX()-1][c.getY()-1]);
			}
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		JButton but = (JButton) e.getSource();
		
		if (!but.getBackground().equals(new Color(0x455A64)) && !but.getBackground().equals(new Color(0x95a5a6))) {
			but.setBackground(new Color(0x2c3e50));
		}
		
	}

	@Override 
	public void mouseExited(MouseEvent e) {
		JButton but = (JButton) e.getSource();
		
		if (!but.getBackground().equals(new Color(0x455A64)) && !but.getBackground().equals(new Color(0x95a5a6))) {
			but.setBackground(new Color(0x2980b9));
		}
	}
	
	public Boolean isTaken(IShip n_ship) {
		int t = 0;
		Boolean taken = false;
		while (taken == false && t < log.getFlotte().getShips().size()) {
			for (int h = 0; h < n_ship.getCoords().size(); h++) {
				if (log.getFlotte().getShips().get(t).getCoords().contains(n_ship.getCoords().get(h))) {
					taken = true;
					log.setMessage("<p style='color: orange;'>Les bateaux ne peuvent pas se chevaucher.</p>");
					log.getTmpCoords().removeAll(log.getTmpCoords());
				}
			}
			t++;
		}
		
		return taken;
	}

	@Override
	public void mouseClicked(MouseEvent e) {
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

}
