package info1.ships;


/**
 * une implementation de l'interface ICoord manipulant des coordonnÃ©es alphanumÃ©riques comme "A1", "B6", "J3", etc.
 */

public class Coord implements ICoord {

    private String xy;

    /**
     * NB : LA SIGNATURE DU CONSTRUCTEUR DOIT ETRE RESPECTEE
     *
     * constructeur d'un objet Coord
     * @param xy la coordonnÃ©e aphanumÃ©rique sous la forme d'une chaine de caractÃ¨res
     * @throws BadCoordException si la chaine de caractÃ¨re ne permet pas de dÃ©finir une coordonnÃ©e alphanumÃ©rique
     */
    public Coord(String xy) throws BadCoordException {
    	CharSequence x =  xy.subSequence(0, 1);
    	CharSequence y = xy.subSequence(1, xy.length());
    	
    	int int_x;

    	switch (x.toString()) {
			case "A":
				int_x = 1;
				 break;
			case "B":
				int_x =  2;
				 break;
			case "C":
				int_x =  3;
				 break;
			case "D":
				int_x =  4;
				 break;
			case "E":
				int_x =  5;
				 break;
			case "F":
				int_x =  6;
				 break;
			case "G":
				int_x =  7;
				 break;
    		case "H":
    			int_x =  8;
				 break;
    		case "I":
    			int_x =  9;
				 break;
    		case "J":
    			int_x = 10;
				 break;
    		default:
    			int_x =  12;
				 break;
    	}
    	
    	if ((int_x >= 1 && int_x <= 10) && (Integer.parseInt(y.toString()) >= 1 && Integer.parseInt(y.toString()) <= 10)) {
    		this.xy = xy;
    	}else {
    		throw new BadCoordException();
    	}
    }

    @Override
    public char getAlphaX() {
    	CharSequence c = xy.subSequence(0, 1);
        return c.charAt(0);
    }
    
    public static String findAlphaX(int n_x) {

    	switch (n_x) {
			case 1:
				return "A";
			case 2:
				return "B";
			case 3:
				return "C";
			case 4:
				return "D";
			case 5:
				return "E";
			case 6:
				return "F";
			case 7:
				return "G";
			case 8:
				return "H";
			case 9:
				return "I";
			case 10:
				return "J";
			default:
				return "O";
    	}
    }

    @Override
    public int getX() {
    	CharSequence x =  xy.subSequence(0, 1);
    	
    	switch (x.toString()) {
			case "A":
				return 1;
			case "B":
				return 2;
			case "C":
				return 3;
			case "D":
				return 4;
			case "E":
				return 5;
			case "F":
				return 6;
			case "G":
				return 7;
    		case "H":
    			return 8;
    		case "I":
    			return 9;
    		default:
    			return 10;
    	}
    }

    @Override
    public int getY() {
    	CharSequence y = xy.subSequence(1, xy.length());
        return Integer.parseInt(y.toString());
    }

    @Override
    public String toString() {
        return  this.xy;
    }

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((xy == null) ? 0 : xy.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Coord other = (Coord) obj;
		if (xy == null) {
			if (other.xy != null)
				return false;
		} else if (!xy.equals(other.xy))
			return false;
		return true;
	}

    
}
