package info1.ships;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


/**
 * Classe dÃ©finissant une flotte de navires
 */

public class NavyFleet implements INavyFleet {

    private int size;
    private List<IShip> flotte;

    /**
     * NB : LA SIGNATURE DU CONSTRUCTEUR DOIT ETRE RESPECTEE
     *
     * Construit une nouvelle flotte
     */
    public NavyFleet() {
        this.size = 20;
        flotte=new ArrayList<IShip>();
    }

    @Override
    public int remainingSize() {
        return this.size;
    }

    @Override
    public boolean isComplete() {
    	return size==0;
    }


    @Override
    public int add(IShip IShip) {
        if(this.flotte.contains(IShip)){
        	return -1;
        }
        else{
        	if(IShip.getSize() > this.size){
        		return -2;
        	}
        	else{
        		for(IShip b : this.flotte){
        			for(ICoord c1 : b.getCoords()){
        				for(ICoord c2: IShip.getCoords()) {
        					if(c1.equals(c2)) {
                				return -3;
        					}
        				}
            		}
        		}
        	}
        	flotte.add(IShip);
        	size=size-IShip.getSize();
        	return 0;
        }
    }

    @Override
    public List<IShip> getShips() {
    	Collections.sort(this.flotte);
    	return this.flotte;
    } 

    @Override
    public Set<IShip> getShips(ShipCategory shipCategory) {
    	Set<IShip> l = new HashSet<>() ;
    	for(IShip b : this.flotte){
    		if(b.getCategory()==shipCategory){
    			l.add(b);
    		}
    	}
        return l; 
    }

    @Override
    public boolean isBelgianConfiguration() {
        if(this.getShips(ShipCategory.BATTLESHIP).size() == 1){
            if(this.getShips(ShipCategory.CRUISER).size() == 2){
                if(this.getShips(ShipCategory.DESTROYER).size() == 3){
                    if(this.getShips(ShipCategory.SUBMARINE).size() == 4){
                    	return true;
                    }
                }
            }
        }
        return false;
    }

    @Override
    public boolean isFrenchConfiguration() {
        if(this.getShips(ShipCategory.BATTLESHIP).size() == 1){
            if(this.getShips(ShipCategory.CRUISER).size() == 2){
                if(this.getShips(ShipCategory.DESTROYER).size() == 2){
                    if(this.getShips(ShipCategory.SUBMARINE).size() == 1){
                        if(this.getShips(ShipCategory.AIRCRAFT_CARRIER).size() == 1){
                        	return true;
                        }
                    }
                }
            }
        }
        return false;
    }
    
    public IShip findShip(ICoord xy){
    	for(IShip b : flotte){
    		for(ICoord c : b.getCoords()){
    			if(c.equals(xy)){
    				return b;
    			}
    		}
    	}
    	return null;
    }

    @Override
    public String toString() {
        String s = null;
        for(IShip b : this.flotte){
        	s = s + b.toString();
        }
        return s;
    }

}
