package vue;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import javax.swing.*;

import com.mashape.unirest.http.exceptions.UnirestException;

import controleur.LocalSave;
import info1.network.BadIdException;
import info1.network.Game;
import info1.network.Network;
import info1.network.Player;
import info1.ships.*;


public class FenLog extends JFrame{
	private static final long serialVersionUID = 1L;
	public static final String HTTP_LOCALHOST = "http://37.187.38.219/api/v0";
	private JPanel p;
	private JLabel l;
	private JTextField txt;
	private JButton b;
	private Player pl;
	private JPanel c1;
	private JButton join;
	private JButton create;
	private JComboBox<Game> list;
	private JButton pos;
	private NavyFleet flotte = new NavyFleet();
	private Game g;
	private int compteur_t;
	private static Color color = new Color(41, 128, 185);
	private static Color color2 = new Color(0x2c3e50);
	private static Color color3 = new Color(52, 73, 94);
	private static Color color4 = new Color(0x2c3e50);
	private static Color buttonColor = new Color(0x34495e);
	private static String fontColor = "#ecf0f1";
	private static String fontColorOpacity = "rgb(230, 234, 235)";

	private JComboBox<String> config;
	private JProgressBar barreVieJoueur1;
	private JProgressBar barreVieJoueur2;
	
	private JPanel p_right;
	private JPanel p_left;
	
	private JButton[][] buttonGrilleHaut;
	private JLabel labelHaut;
	private JLabel labelGauche;
	

	private JButton[][] buttonGrilleBas;
	private JLabel resultatCoup;
	private JLabel resultatTir;
	private JLabel porteAvions ;
	private JProgressBar barreViePorteAvions;
	private JLabel croiseur;
	private JProgressBar barreVieCroiseur;
	private JLabel cuirasse;
	private JProgressBar barreVieCuirasse;
	private JLabel sousMarin;
	private JProgressBar barreVieSousMarin;
	private JLabel torpilleur;
	private JProgressBar barreVieTorpilleur;
	private JButton[][] buttonGrilleC;
	private JPanel grilleC;
	
	private ArrayList<Coord> tmp_coords = new ArrayList<>();
	private int etape = 1;
	private JPanel principalHaut = new JPanel(); // panel qui contiendra la grille et les lettres
	private JButton bu_reset = new JButton("Réinitialiser");
	private JLabel creation_mess = new JLabel("<html>Cliquez sur une case pour choisir l'avant du cuirassé puis sur une deuxième pour sélectionner l'arrière. (Longueur : 4)</html>");
	
	public FenLog(){
		try {
            UIManager.setLookAndFeel( UIManager.getCrossPlatformLookAndFeelClassName() );
        } catch (Exception e) {
            e.printStackTrace();
        }
		
        this.setTitle("Bataille Navale");
        ImageIcon icon = new ImageIcon("img/minilog.png");
        JLabel img=new JLabel(icon);
        JLabel blanc = new JLabel();
        blanc.setMaximumSize(new Dimension(10,20));
        this.setIconImage(icon.getImage());
        this.setBackground(color4);
        p = new JPanel(new GridLayout(1,2));
        p_left=new JPanel(); 
        p_left.add(img);
        p_right=new JPanel();
        p.setBackground(color4);
        l = new JLabel("<html><p style='color: "+ fontColor +";'>Entre ton nom</p></html>");
        JLabel l2 = new JLabel("<html><p style='color: "+ fontColor +";'>Choisi ta configuration :</p></html>");
		String pname = null;
		try {
			pname = LocalSave.getInfos(1);
		} catch (Exception e) {
			e.printStackTrace();
		}

		config = new JComboBox<>();
		config.addItem("Française");
		config.addItem("Belge");
		config.setMaximumSize(new Dimension(500,20));
		config.setBackground(new Color(233, 240, 255));
        txt = new JTextField(pname);
        txt.setMaximumSize(new Dimension(500,20));
        txt.setBackground(new Color(233, 240, 255));
        b = new JButton("<html><p style='color : "+ fontColor +";'>OK</p></html>");
        b.setBackground(buttonColor);
        l.setAlignmentX(Component.CENTER_ALIGNMENT);
        l2.setAlignmentX(Component.CENTER_ALIGNMENT);
        txt.setAlignmentX(Component.CENTER_ALIGNMENT);
        b.setAlignmentX(Component.CENTER_ALIGNMENT);
        config.setAlignmentX(Component.CENTER_ALIGNMENT);
        p_right.add(blanc);
        p_right.add(l); 
        p_right.add(txt);
        p_right.add(l2);
        p_right.add(config);
        p_right.add(b);
        p_right.setLayout(new BoxLayout(p_right,1));
        p_right.setBackground(color4);
        p_left.setBackground(color4);

        p.add(p_left);
        p.add(p_right);
        this.setContentPane(p);
        
        this.setPreferredSize(new Dimension(380, 200));
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
        int x = (int) ((dimension.getWidth() - 300) / 2);
        int y = (int) ((dimension.getHeight() - 200) / 2);
        this.setLocation(x, y);
        this.pack();
        this.setVisible(true);
        this.join = new JButton("<html><p style='color : "+ fontColor +";'>join</p></html>");
        this.join.setBackground(buttonColor);
        this.create = new JButton("<html><p style='color : "+ fontColor +";'>créer</p></html>");
        this.create.setBackground(buttonColor);
        this.pos = new JButton("<html><p style='color : "+ fontColor +";'>flotte</p></html>");
        this.pos.setBackground(buttonColor);

        
        
        // GRILLE
		String[] alphabet = {"A" ,"B", "C", "D", "E", "F", "G", "H", "I", "J"}; // alphabet utilis�s pour les grilles
		String tmp;
		
		String[] chiffres = {" ","1","2","3","4","5","6","7","8","9","10"}; // chiffres utilis�s pour les grilles
		String temp;
		
		// ainsi que les chiffres
		principalHaut.setLayout(new BorderLayout());
		
			JPanel PanelGaucheGH = new JPanel(); // panel qui contient les lettres du la grille
			// du dessus
			PanelGaucheGH.setLayout(new GridLayout(10,1));
			
			for(int i=0; i<10; i++) { // mise en place des lettres
				tmp=alphabet[i];
				labelGauche = new JLabel(tmp);
				labelGauche.setHorizontalAlignment(SwingConstants.CENTER);
				PanelGaucheGH.add(labelGauche);
			}
			
			principalHaut.add(PanelGaucheGH, BorderLayout.WEST); // ajout du panel des lettres
			// à celui qui contient la grille du dessus

			JPanel PanelHautGH = new JPanel(); //panel qui contiendra les chiffres de la 
			// grille du dessus
			PanelHautGH.setLayout(new GridLayout(1,10));
			
			String espace = chiffres[0];
			labelHaut = new JLabel(espace);
			PanelHautGH.add(labelHaut);
			for(int i=1; i<11; i++) { // mise en place des chiffres
				temp=chiffres[i];
				labelHaut = new JLabel(temp);
				labelHaut.setVerticalAlignment(SwingConstants.CENTER);
				PanelHautGH.add(labelHaut);
			}
			
			principalHaut.add(PanelHautGH, BorderLayout.NORTH); // ajout du panel des chiffres
			// à celui qui contient la grille de dessus
			
			JPanel grilleHaut = new JPanel(); // panel qui contient la grille
			grilleHaut.setLayout(new GridLayout(10,10));
			principalHaut.add(grilleHaut, BorderLayout.CENTER);
				
			buttonGrilleHaut = new JButton[10][10]; 
			for(int i=0; i<10; i++) { // remplissage de la grille
				for(int j=0; j<10; j++) {
					buttonGrilleHaut[i][j] = new JButton(" ");
					grilleHaut.add(buttonGrilleHaut[i][j]);
					buttonGrilleHaut[i][j].setBackground(new Color(0x2980b9));
					int x1 = i+1;
					int y1 = j+1;
					buttonGrilleHaut[i][j].setName(Coord.findAlphaX(x1)+""+y1);
				}
			}
			PanelHautGH.setBackground(color2);
			PanelGaucheGH.setBackground(color2);
			grilleHaut.setBackground(color2);
			
			//autregrille
			grilleC = new JPanel(); // panel qui contient la grille
			grilleC.setLayout(new GridLayout(10,10));
			grilleC.setBackground(color2);
				
				buttonGrilleC = new JButton[10][10]; 
				for(int i=0; i<10; i++) { // remplissage de la grille
					for(int j=0; j<10; j++) {
						buttonGrilleC[i][j] = new JButton(" ");
						grilleC.add(buttonGrilleC[i][j]);
						buttonGrilleC[i][j].setBackground(Color.blue);
						x = i + 1;
						y = j + 1;
						buttonGrilleC[i][j].setName(Coord.findAlphaX(x) + "" + y);
					}
				}
        
    }
	
	public void setdam(int i){
		if(i == 1){
			int v = barreVieJoueur1.getValue()-1;
			barreVieJoueur1.setValue(v);
			majVie(barreVieJoueur1);
		}
		if(i == 2){
			int v = barreVieJoueur2.getValue()-1;
			System.out.println(v);
			barreVieJoueur2.setValue(v);
			majVie(barreVieJoueur2);
		}
	}
	
	public Game getSelectGame(){
		return (Game) this.list.getSelectedItem();
	}
	
	public String getName(){
		return txt.getText();
	}
	
	public void setG(Game g){
		this.g = g;
	}
	
	public Game getG(){
		return this.g;
	}
	
	public Player getPL(){
		return this.pl;
	}
	
	public NavyFleet getFlotte(){
		return this.flotte;
	}
	
	public void SetPl(Player p){
		this.pl = p;
	}
	
	public void setTxt(String s){
		this.txt.setText(s);
	}
	
	public void fixeListenerb(ActionListener action) {
        b.addActionListener(action);
    }
	
	public void fixeListenerJoin(ActionListener action) {
        join.addActionListener(action);
    }
	
	public void fixeListenerCreate(ActionListener action) {
        create.addActionListener(action);
    }
	
	public void fixeListenerPos(ActionListener action) {
        pos.addActionListener(action);
    }
	
	public void goCreateFlotte(int config) {
		this.getContentPane().removeAll();
		 this.repaint();
		 

		 
		 // DEF CONFIG
		 if (!flotte.isBelgianConfiguration() && !flotte.isFrenchConfiguration()) {
			 this.resetEtape();
		 }else {
			 etape = 18;
			 setMessage("La flotte à déjà était créé. Pour en créer une autre, cliquez sur 'réinitialiser' ou cliquez sur une case pour revenir en arrière.");
		 }
		 
		 // CONSTRUCTION DE LA VUE
		 p = new JPanel();
		 p.setLayout(new GridLayout(1, 3));

		 // PANEL DE GAUCHE
		 // IMAGE DES BATEAUX
		 ImageIcon azurain_icon = new ImageIcon("img/azurain.png");
		 JLabel azurain_img = new JLabel(azurain_icon);
		 
		 ImageIcon crois_icon = new ImageIcon("img/crois.png");
		 JLabel crois_img = new JLabel(crois_icon);
		 
		 ImageIcon cuir_icon = new ImageIcon("img/cuir.png");
		 JLabel cuir_img = new JLabel(cuir_icon);
		 
		 ImageIcon sous_icon = new ImageIcon("img/sous.png");
		 JLabel sous_img = new JLabel(sous_icon);
		 
		 ImageIcon torp_icon = new ImageIcon("img/torp.png");
		 JLabel torp_img = new JLabel(torp_icon);
		 
		 JPanel left = new JPanel();
		 GridLayout left_l = new GridLayout(5, 1);
		 left.setLayout(left_l);
		 left.setBackground(color4);
		 
		 left.add(azurain_img);
		 left.add(crois_img);
		 left.add(cuir_img);
		 left.add(sous_img);
		 left.add(torp_img);

		 p.add(left);
		 
		// GRILLE
		JPanel droite_grille = new JPanel(new BorderLayout());
		droite_grille.setBackground(color4);

		droite_grille.add(principalHaut, BorderLayout.CENTER);
		droite_grille.add(creation_mess, BorderLayout.NORTH);

		bu_reset.setBackground(new Color(0xc0392b));
		
		droite_grille.add(bu_reset, BorderLayout.SOUTH);
				
		p.add(droite_grille);
		
		this.setContentPane(p);

      this.setPreferredSize(new Dimension(950, 350));
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
      int x = (int) ((dimension.getWidth() - 950) / 2);
      int y = (int) ((dimension.getHeight() - 350) / 2);
      this.setLocation(x, y);
      this.pack();
      this.setVisible(true);
		 
	}
	
	public void goMenu(){
		this.getContentPane().removeAll();
		 this.repaint();
		 ImageIcon icon = new ImageIcon("img/gifGoMenu.gif");
		 JLabel img = new JLabel(icon);
		 p = new JPanel();
		 p.setBackground(color4);
		 p.setLayout(new BorderLayout());
		 c1 = new JPanel();
		 JPanel c2 = new JPanel();
		 c2.setLayout(new BorderLayout());
		 try {
			List<Game> lp = Network.listInitializedGames(HTTP_LOCALHOST);
			this.list = new JComboBox<Game>();
			for(Game g : lp){
				this.list.addItem(g);
			}
		} catch (UnirestException e) {
			e.printStackTrace();
		}
		this.list.setBackground(new Color(233, 240, 255));
		this.list.setPreferredSize(new Dimension(250,25));
		c1.setBackground(color4);
		c1.add(create);
		c1.add(list);
		c1.add(join);
		c1.add(pos);
		c2.add(c1, BorderLayout.NORTH);
		try {
			JLabel ply = new JLabel("<html><p style='margin: 10px; width: 600; color: "+ fontColorOpacity +"; text-align: center;'>Joueur: "+ LocalSave.getInfos(1)+"&nbsp;&nbsp;&nbsp;Partie jouées: "+LocalSave.getInfos(2)+"&nbsp;&nbsp;&nbsp;Partie gagnées: "+LocalSave.getInfos(3)+"&nbsp;&nbsp;&nbsp;partie perdues: "+LocalSave.getInfos(4)+"</p></html>");
			c2.add(ply, BorderLayout.SOUTH);
		} catch (Exception e) {
			e.printStackTrace();
		}
		c2.setBackground(color3);
		p.add(c2, BorderLayout.NORTH);
		p.add(img, BorderLayout.CENTER);

		this.setContentPane(p);
		
		this.setPreferredSize(new Dimension(600, 400));
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
     Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
     int x = (int) ((dimension.getWidth() - 600) / 2);
     int y = (int) ((dimension.getHeight() - 400) / 2);
     this.setLocation(x, y);
		this.pack();
		this.setVisible(true);
	}
	
	public int getCompt(){
		return this.compteur_t;
	}

	public void incrCompt(){
		this.compteur_t++;
	}

	
	public void goCombat() {
		 this.getContentPane().removeAll();
		 this.repaint();
		 
		 this.compteur_t = 0;
		 
		 
		 
		// super(titre);
			//titre="Bataille navale";
			ImageIcon icon = new ImageIcon("img/minilog.png");
			this.setIconImage(icon.getImage());
			
			JPanel principalBataille = new JPanel(); // panel qui contient la fenetre de la bataille
			principalBataille.setLayout(new GridLayout(3,1));
			principalBataille.setBorder(BorderFactory.createTitledBorder("Bataille Navale"));
			principalBataille.setBackground(color);
			
			String[] alphabet = {"A" ,"B", "C", "D", "E", "F", "G", "H", "I", "J"}; // alphabet utilises pour les grilles
			String tmp;
			
			String[] chiffres = {" ","1","2","3","4","5","6","7","8","9","10"}; // chiffres utilises pour les grilles
			String temp;
			
			JPanel principalHaut = new JPanel(); // panel qui contiendra la grille et les lettres
			// ainsi que les chiffres
			principalHaut.setLayout(new BorderLayout());
			principalBataille.add(principalHaut);
			
				JPanel PanelGaucheGH = new JPanel(); // panel qui contient les lettres du la grille
				// du dessus
				PanelGaucheGH.setLayout(new GridLayout(10,1));
				
				for(int i=0; i<10; i++) { // mise en place des lettres
					tmp=alphabet[i];
					labelGauche = new JLabel(tmp);
					labelGauche.setHorizontalAlignment(SwingConstants.CENTER);
					PanelGaucheGH.add(labelGauche);
					PanelGaucheGH.setBackground(color2);
				}
				
				principalHaut.add(PanelGaucheGH, BorderLayout.WEST); // ajout du panel des lettres
				// a celui qui contient la grille du dessus

				JPanel PanelHautGH = new JPanel(); //panel qui contiendra les chiffres de la 
				// grille du dessus
				PanelHautGH.setLayout(new GridLayout(1,10));
				
				String espace = chiffres[0];
				labelHaut = new JLabel(espace);
				PanelHautGH.add(labelHaut);
				for(int i=1; i<11; i++) { // mise en place des chiffres
					temp=chiffres[i];
					labelHaut = new JLabel(temp);
					labelHaut.setVerticalAlignment(SwingConstants.CENTER);
					PanelHautGH.add(labelHaut);
					PanelHautGH.setBackground(color2);
				}
				
				principalHaut.add(PanelHautGH, BorderLayout.NORTH); // ajout du panel des chiffres
				// a celui qui contient la grille de dessus
				
					
			JPanel principalCentre = new JPanel(); // panel qui contient un label au centre
			principalCentre.setLayout(new BorderLayout());
			principalBataille.add(principalCentre);
			
				
				JPanel resultatTirInfoTir = new JPanel(); // panel qui comprend un label et l'info du tir
				resultatTirInfoTir.setLayout(new GridLayout(1,2));
				resultatTirInfoTir.setBackground(color2);
				principalCentre.add(resultatTirInfoTir, BorderLayout.CENTER);
				
				resultatTir = new JLabel("Resultat du coup:   ");  // JLabel purement esthetique pour le fonctionnement du jeux
				//System.out.println(resultatCoup);
				resultatTir.setHorizontalAlignment(SwingConstants.RIGHT);
				//resultatTir.setVerticalAlignment(SwingConstants.CENTER);
				resultatTirInfoTir.add(resultatTir);
			
				resultatCoup = new JLabel(); //JTextArea qui indique le resulstat de notre coup
				resultatCoup.setHorizontalAlignment(SwingConstants.LEFT);
				//resultatCoup.setVerticalAlignment(SwingConstants.CENTER);
				resultatTirInfoTir.add(resultatCoup);
			
			JPanel principalBas = new JPanel(); // panel qui contient la grille de dessous, les chiffres
			// de la grille de dessous ainsi que les lettres
			principalBas.setLayout(new BorderLayout());
			principalBataille.add(principalBas, BorderLayout.SOUTH);
				
				JPanel PanelHautGB = new JPanel(); // panel qui contient les les lettres de la grille 
				// du dessous
				PanelHautGB.setLayout(new GridLayout(10,1));
					
				for(int i=0; i<10; i++) { // mise en place de lettres
					tmp=alphabet[i];
					labelHaut = new JLabel(tmp);
					labelHaut.setHorizontalAlignment(SwingConstants.CENTER);
					PanelHautGB.add(labelHaut);
					labelHaut.setBackground(color2);
				}
				
				PanelHautGB.setBackground(color2);	
				principalBas.add(PanelHautGB, BorderLayout.WEST); // ajout du panel qui contient les 
				// lettre a celui qui contient la grille du dessous
				principalHaut.add(grilleC, BorderLayout.CENTER);
				grilleC.setBackground(color2);

				JPanel PanelGaucheGB = new JPanel(); // panel qui contient les chiffres de la grille
				// de dessous
				PanelGaucheGB.setLayout(new GridLayout(1,10));
				
				for(int i=1; i<11; i++) { // mise en place des chiffres
					labelGauche = new JLabel(" " + i);
					labelGauche.setVerticalAlignment(SwingConstants.CENTER);
					PanelGaucheGB.add(labelGauche);
					PanelGaucheGB.setBackground(color2);
				}
				
				principalBas.add(PanelGaucheGB, BorderLayout.NORTH); // ajout du panel qui contient 
				//les chiffres a celui qui contient la grille du dessous
			
				JPanel grilleBas = new JPanel(); // panel qui contient la grille du dessous
				grilleBas.setLayout(new GridLayout(10,10));
				principalBas.add(grilleBas, BorderLayout.CENTER);
				grilleBas.setBackground(color2);
				
				buttonGrilleBas = new JButton[10][10]; 
                for(int i=0; i<10; i++) { // remplissage de la grille
                    for(int j=0; j<10; j++) {
                        buttonGrilleBas[i][j] = new JButton("");
                        grilleBas.add(buttonGrilleBas[i][j]);
                        int x = i + 1;
                        int y = j + 1;
                        String s=Coord.findAlphaX(x) + "" + y;
                        Coord c;
                        try {
                            c = new Coord(s);
                            if(flotte.findShip(c)!=null) {
                                buttonGrilleBas[i][j].setBackground(Color.gray);
                            }
                            else {
                                buttonGrilleBas[i][j].setBackground(Color.white);

                            }
                        }
                        catch (BadCoordException e) {
                            e.printStackTrace();
                        }
                        
                        
                    }
				}



    			JPanel principal = new JPanel(); // panel qui contient la fenetre
    			principal.setLayout(new GridLayout(1,2));
    			principal.add(principalBataille);
    			principalBataille.setBackground(color2);
    			
    			
    			JPanel gestionBateaux = new JPanel(); // panel qui va gerer les bateaux 
    			gestionBateaux.setLayout(new GridLayout(3,1));
    			principal.add(gestionBateaux, BorderLayout.EAST);
    			gestionBateaux.setBorder(BorderFactory.createLoweredBevelBorder());
    			
    			JPanel placementRadar = new JPanel();
    			placementRadar.setBackground(Color.black);
    			placementRadar.setLayout(new FlowLayout());
    			gestionBateaux.add(placementRadar);
    			
    				ImageIcon gifRadar  = new ImageIcon("img/a.gif"); // affichage de l'image du porte-avion
    				JLabel radar = new JLabel(gifRadar);
    				placementRadar.add(radar);
    								
    			JPanel bateaux = new JPanel();
    			bateaux.setLayout(new GridLayout(6,2));
    			gestionBateaux.add(bateaux);
    				
    				if(this.flotte.isFrenchConfiguration()){
    					ImageIcon imgPorteAvions  = new ImageIcon("img/azurain.png"); // affichage de l'image du porte-avion
    					porteAvions = new JLabel(imgPorteAvions);
    					bateaux.add(porteAvions);
    					JLabel InfoViePorteAvion = new JLabel("vie porte-avions"); 
    					InfoViePorteAvion.setVerticalAlignment(SwingConstants.CENTER);
    					bateaux.add(InfoViePorteAvion);
    				
    					JPanel AffichageVieporteAvions = new JPanel(); // panel qui contient la barre de vie du porte-avions
    					AffichageVieporteAvions.setLayout(new FlowLayout());
    					bateaux.add(AffichageVieporteAvions);
    				
    					barreViePorteAvions = new JProgressBar(0,5); // barre de vie du porte-avions
    					barreViePorteAvions.setValue(5);
    					barreViePorteAvions.setForeground(new Color(58, 160, 255));
    					barreViePorteAvions.setStringPainted(true);
    					AffichageVieporteAvions.add(barreViePorteAvions);
    					AffichageVieporteAvions.setBackground(color3);
    				}
    				
    				ImageIcon imgCroiseur = new ImageIcon("img/crois.png"); // affichage de l'image du croiseur
    				croiseur = new JLabel(imgCroiseur);
    				bateaux.add(croiseur);
    				JLabel InfoVieCroiseur = new JLabel("vie croiseurs");
    				bateaux.add(InfoVieCroiseur);
    				
    					JPanel AffichageVieCroiseur = new JPanel();  // panel qui contient la barre de vie du croiseur
    					AffichageVieCroiseur.setLayout(new FlowLayout());
    					bateaux.add(AffichageVieCroiseur);
    				
    				barreVieCroiseur = new JProgressBar(0,6); // barre de vie du croiseur
    				barreVieCroiseur.setValue(6);
    				barreVieCroiseur.setForeground(new Color(58, 160, 255));
    				barreVieCroiseur.setStringPainted(true);
    				AffichageVieCroiseur.add(barreVieCroiseur);
    				AffichageVieCroiseur.setBackground(color3);
    				
    				ImageIcon imgCuirasse = new ImageIcon("img/cuir.png"); // affichage de l'image du cuirasse
    				cuirasse = new JLabel(imgCuirasse);
    				bateaux.add(cuirasse);
    				JLabel InfoVieCuirasse = new JLabel("vie cuirasses");
    				bateaux.add(InfoVieCuirasse);
    				
    					JPanel AffichageVieCuirasse = new JPanel(); // panel qui contient la barre de vie du cuirasse
    					AffichageVieCuirasse.setLayout(new FlowLayout());
    					bateaux.add(AffichageVieCuirasse);
    				
    				barreVieCuirasse = new JProgressBar(0,4); // barre de vie du cuirasse
    				barreVieCuirasse.setValue(4);
    				barreVieCuirasse.setForeground(new Color(58, 160, 255));
    				barreVieCuirasse.setStringPainted(true);
    				AffichageVieCuirasse.add(barreVieCuirasse);
    				AffichageVieCuirasse.setBackground(color3);
    				
    				ImageIcon imgSousMarin = new ImageIcon("img/sous.png"); // affichage de l'image du sous-marin
    				sousMarin = new JLabel(imgSousMarin);
    				bateaux.add(sousMarin);
    				JLabel InfoVieSousMarin = new JLabel("vie sous-marins");
    				bateaux.add(InfoVieSousMarin);
    				
    					JPanel AffichageVieSousMarin = new JPanel(); // affichage de l'image du sous-marin
    					AffichageVieSousMarin.setLayout(new FlowLayout());
    					bateaux.add(AffichageVieSousMarin);
    				
        			if(this.flotte.isFrenchConfiguration()){
        				barreVieSousMarin = new JProgressBar(0,1); // barre de vie du sous-marin
        				barreVieSousMarin.setValue(1);
        			}else{
        				barreVieSousMarin = new JProgressBar(0,4); // barre de vie du sous-marin
        				barreVieSousMarin.setValue(4);
        			}
    				barreVieSousMarin.setForeground(new Color(58, 160, 255));
    				barreVieSousMarin.setStringPainted(true);
    				AffichageVieSousMarin.add(barreVieSousMarin);
    				AffichageVieSousMarin.setBackground(color3);
    				
    				ImageIcon imgTorpilleur = new ImageIcon("img/torp.png"); // affichage de l'image du torpilleur
    				torpilleur = new JLabel(imgTorpilleur);
    				bateaux.add(torpilleur);
    				JLabel InfoVieTorpilleur = new JLabel("vie torpilleurs");
    				bateaux.add(InfoVieTorpilleur);
    				
    					JPanel AffichageTorpilleur = new JPanel(); // affichage de l'image du torpilleur
    					AffichageTorpilleur.setLayout(new FlowLayout());
    					bateaux.add(AffichageTorpilleur);
    					AffichageTorpilleur.setBackground(color3);
    					bateaux.setBackground(color3);
    				
            		if(this.flotte.isFrenchConfiguration()){
            			barreVieTorpilleur = new JProgressBar(0,4); // barre de vie du torpilleur
            			barreVieTorpilleur.setValue(4);
            		}else{
            			barreVieTorpilleur = new JProgressBar(0,6); // barre de vie du sous-marin
            			barreVieTorpilleur.setValue(6);
            		}
    				barreVieTorpilleur.setForeground(new Color(58, 160, 255));
    				barreVieTorpilleur.setStringPainted(true);
    				AffichageTorpilleur.add(barreVieTorpilleur);
    				AffichageTorpilleur.setBackground(color3);
    				
    			JPanel vieJoueurNom = new JPanel(); // panel qui contient un JLabel indiquant la vie des joueurs
    			vieJoueurNom.setBackground(color4);
    			vieJoueurNom.setLayout(new GridLayout(4,2));
    			gestionBateaux.add(vieJoueurNom);
    			vieJoueurNom.setBorder(BorderFactory.createTitledBorder("barre de vie des joueurs"));
    			
    			UIManager.put("ProgressBar.selectionForeground",Color.BLACK);
    				JLabel joueur1 = new JLabel("Votre Flotte: "); // creation de la barre de vie du joueur n 1
    				vieJoueurNom.add(joueur1);
    				barreVieJoueur1 = new JProgressBar(0,20);
    				barreVieJoueur1.setForeground(new Color(17,185,17));
    				barreVieJoueur1.setValue(20);
    				barreVieJoueur1.setStringPainted(true);
    				vieJoueurNom.add(barreVieJoueur1);
    				
    				JLabel joueur2 = new JLabel("Flotte ennemie: "); // creation de la barre de vie du joueur n 2
    				vieJoueurNom.add(joueur2);
    				barreVieJoueur2 = new JProgressBar(0,20);
    				barreVieJoueur2.setValue(20);
    				barreVieJoueur2.setForeground(new Color(17,185,17));
    				barreVieJoueur2.setStringPainted(true);
    				vieJoueurNom.add(barreVieJoueur2);
    					
			this.getContentPane().add(principal); // affiche la fenetre 
			this.setPreferredSize(new Dimension(900, 700));
			this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			this.pack();
		    Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		    int x = (int) ((dimension.getWidth() - 900) / 2);
		    int y = (int) ((dimension.getHeight() - 700) / 2);
		    this.setLocation(x, y);
			this.setVisible(true);
			
	}
	
	public void majVie(JProgressBar vie){
		if(vie.getValue()*5 > 60 ){
			vie.setForeground(new Color(17,185,17));
		}
		else if(vie.getValue()*5 > 30){
			vie.setForeground(new Color(252,255,75));
		}
		else if(vie.getValue()*5 > 10){
			vie.setForeground(new Color(255,137,33));
		}
		else{
			vie.setForeground(new Color(238,40,40));
		}
	}
	
	public void Jouer() {
		try {
			TimeUnit.SECONDS.sleep(3);
			while(!partieGagné()||!partiePerdu()) {
				
				if(myTurn()) {
					this.enabledButton();
					this.setResultatCoup("en attente d'un coup");
				}
				else if(notMyTurn()) {
					this.disabledButton();
				}
			}
		} catch (UnirestException | BadIdException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	public boolean partieInitialiser() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==1;
			
		}
	public boolean partieJoin() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==-1;
			
	}
	public boolean myTurn() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==10;
	}
	public boolean notMyTurn() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==-10;
	}
	
	public boolean partieGagné() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==100;
	}
	public boolean partiePerdu() throws UnirestException, BadIdException {
		return Network.getInfo(HTTP_LOCALHOST, g, pl)==-100;
	}
	
	public void disabledButton() {
		for(int i=0;i<10;i++) {
			for(int j=0;j<10;j++) {
				buttonGrilleC[i][j].disable();
			}
		}
	}
	public void enabledButton() {
		for(int i=0;i<10;i++) {
			for(int j=0;i<10;i++) {
				buttonGrilleC[i][j].enable();
			}
		}
	}
	
	public ArrayList<Coord> getTmpCoords() {
		return tmp_coords;
	}
	
	public int getEtapeCreation() {
		return etape;
	}

	public void increaseEtapeCreation() {
		etape++;
	}

	public JButton[][] getButtonGrilleHaut() {
		return buttonGrilleHaut;
	}
	
	public JButton[][] getButtonGrilleC() {
		return buttonGrilleC;
	}
	
	public void fixeListenerCase(ActionListener action, MouseListener mouse) {
		for(int i=0; i<10 ;i++) {
			for(int j=0; j<10; j++) {
				buttonGrilleHaut[i][j].addActionListener(action);
				buttonGrilleHaut[i][j].addMouseListener(mouse);
			}
		}	
	}
	
	public void fixeListenerCase(ActionListener action) {
		for(int i=0; i<10 ;i++) {
			for(int j=0; j<10; j++) {
				buttonGrilleC[i][j].addActionListener(action);
			}
		}	
	}
	
	public void fixeListenerResetFlotte(ActionListener action) {
		bu_reset.addActionListener(action);
	}
	
	public void setMessage(String mess) {
		creation_mess.setText("<html>" + mess + "</html>");
	}

	
	public void colorizeNone(JButton button) { // colorie le bouton selon le r�sultat (blanc si rat�)
		button.setBackground(Color.white);
	}
	
	public int getConfig(){
		return this.config.getSelectedIndex();
	}

	public JLabel getResultatCoup() { // getter du TextArea qui affiche le resulstat du coup
		return resultatCoup;
	}
	
	public void setResultatCoup(String info) { // setter du TextArea qui affiche le resultat du coup
		 resultatCoup.setText(info);
	}
	
	public void colorizeTouch(JButton button) { // colorie le bouton selon le resultat (rouge si touche)
		button.setBackground(new Color(255,116,0));
	}
	
	public void colorizeCoule(JButton button) { // colorie le bouton selon le resultat (gris si coule)
		button.setBackground(Color.red);
	}
	
	public JProgressBar getBarrePorteAvions() { // getter de la barre due vie du porte-avions
		return barreViePorteAvions;
	}
	
	public JProgressBar getBarreCroiseur() { // getter de la barre due vie du croiseur
		return barreVieCroiseur;
	}
	
	public JProgressBar getBarreCuirasse() { // getter de la barre due vie du cuirasse
		return barreVieCuirasse;
	}
	
	public JProgressBar getBarreSousMarin() { // getter de la barre due vie du sous-arin
		return barreVieSousMarin;
	}
	
	public JProgressBar getBarreTorpilleur() { // getter de la barre due vie du torpilleur
		return barreVieTorpilleur;
	}
	
	public void resetEtape() {
		if (getConfig() == 0) {
			this.etape = 1;
			this.setMessage("Placer votre cuirassé (longueur : 4)");
		}else {
			this.etape = 8;
			this.setMessage("Placer votre cuirassé (longueur : 4)");
		}
	}
	
	public void resetFlotte() {
		this.flotte = new NavyFleet();
	}
	
	public void resetGrilleColorButton() {
		for(int i=0;i<10;i++) {
			for(int j=0;j<10;j++) {
				buttonGrilleHaut[i][j].setBackground(new Color(0x2980b9));;
			}
		}
	}

	public void tir_recu(String pos, JButton cible) throws BadCoordException{
		IShip ship = this.flotte.findShip(new Coord(pos));
		if(ship == null){
			this.colorizeNone(cible);
		}
		else{
			this.setdam(1);
			this.colorizeTouch(cible);
			if(ship.getCategory() == ShipCategory.BATTLESHIP){
				int v = this.barreVieCuirasse.getValue()-1;
				this.barreVieCuirasse.setValue(v);	
			}
			if(ship.getCategory() == ShipCategory.CRUISER){
				int v = this.barreVieCroiseur.getValue()-1;
				this.barreVieCroiseur.setValue(v);
			}
			if(ship.getCategory() == ShipCategory.DESTROYER){
				int v = this.barreVieTorpilleur.getValue()-1;
				this.barreVieTorpilleur.setValue(v);
			}
			if(ship.getCategory() == ShipCategory.SUBMARINE){
				int v = this.barreVieSousMarin.getValue()-1;
				this.barreVieSousMarin.setValue(v);
			}
			if(ship.getCategory() == ShipCategory.AIRCRAFT_CARRIER){
				int v = this.barreViePorteAvions.getValue()-1;
				this.barreViePorteAvions.setValue(v);
			}
		}
		
		
	}
}